// ObjFile.h: interface for the ObjFile class.
//
//////////////////////////////////////////////////////////////////////

#pragma once

#include <QVector>
#include <QtOpenGL>

#include <stdio.h>
#include <float.h>

#include "Vector.h"

using namespace std;

struct tFace
{
	QVector <int> vertIndex;
	QVector <int> coordIndex;
	QVector <int> normalIndex;
	Vector3 faceNormal;
};

class ObjFileSimple
{
private:


public:
        ObjFileSimple();
        ~ObjFileSimple();

        bool SimpleRead(const char * sFilePath);
        void Normalize();
        bool Write(const char * filename);

        void GetVerts(QVector <Vector3> & verts);
        void GetFaces(QVector <QVector <int> > & faces);

private:

        QVector <Vector3> vertlist;
        QVector <Vector3> normlist;
        QVector <tFace> facelist;

};

