#include "PPMFile.h"

PPMFile::PPMFile()
{
}

bool PPMFile::ReadFile(char *filename) {

    int numBytes;
    char inputBuffer[25];

    FILE *_f=fopen(filename,"r");
    if (_f == NULL)
        return false;

    fread(inputBuffer,sizeof(char),25,_f);
    QString headerString=QString(inputBuffer);
    QStringList headerSplit=headerString.split(" ");

    width=headerSplit[1].toInt();
    height=headerSplit[2].toInt();

    qDebug("Detected width/height: %i/%i",width,height);

    numBytes=width*height*3;

    fclose(_f);

    _f=fopen(filename,"rb");

    int numSpaceRead=0;
    while (numSpaceRead<4) {
        int eachChar=fgetc(_f);
        if (eachChar==' ')
            numSpaceRead++;
    }
    //fseek(_f,15,SEEK_SET);

    unsigned char *origDataArray=new unsigned char[width*height*3];
    fread(origDataArray,width*height*3,1,_f);
    fclose(_f);

    //convert to int type
    dataArray=new int[width*height];
    for (int y=0;y<height;y++)
        for (int x=0;x<width;x++)
            dataArray[y*width+x]=origDataArray[(y*width+x)*3];

    float minDiv=min(width,height);

    //populate verts
    for (int y=0;y<height;y++) {
        for (int x=0;x<width;x++) {

            m_vVertices.push_back(Vector3((float)x/(float)minDiv,1.0f-(float)dataArray[y*width+x]/255.0f,(float)y/(float)minDiv));

            if (origDataArray[3*(y*width+x)+2]>0) //if blue channel is nonzero, this is a uv coord, push it back
                triangleBounds.push_back(m_vVertices[m_vVertices.size()-1]);
        }
    }

    //populate faces
    for (int x=0;x<width-1;x++) {
        for (int y=0;y<height-1;y++) {

            QVector <int> eachFace1, eachFace2;
            int ind[4];
            ind[0]=y*width+x;
            ind[1]=y*width+x+1;
            ind[2]=(y+1)*width+x;
            ind[3]=(y+1)*width+x+1;

            eachFace1.push_back(ind[0]);
            eachFace1.push_back(ind[1]);
            eachFace1.push_back(ind[2]);

            eachFace2.push_back(ind[1]);
            eachFace2.push_back(ind[3]);
            eachFace2.push_back(ind[2]);

            if (dataArray[ind[0]]<255&&dataArray[ind[1]]<255&&dataArray[ind[2]]<255)
                m_vFaces.push_back(eachFace1);
            if (dataArray[ind[1]]<255&&dataArray[ind[2]]<255&&dataArray[ind[3]]<255)
                m_vFaces.push_back(eachFace2);

        }
    }

    delete [] origDataArray;

    return true;

}

QVector <Vector3> PPMFile::GetVerts() {
	return m_vVertices;
}

QVector <QVector <int> > PPMFile::GetFaces() {
	return m_vFaces;
}

QVector <Vector3> PPMFile::GetTriangleBounds() {
	return triangleBounds;
}

int *PPMFile::GetData() {
	return dataArray;
}

int PPMFile::GetWidth() {
	return width;
}

int PPMFile::GetHeight() {
	return height;
}
