#pragma once

#include <stdio.h>
#include <QVector>
#include <float.h>
#include <QtCore>

#include "Vector.h"

using namespace std;

class PPMFile
{
public:
    PPMFile();	
    bool ReadFile(char *filename);

    QVector <Vector3> GetVerts();
    QVector <QVector <int> > GetFaces();

    QVector <Vector3> GetTriangleBounds();

    int *GetData();
    int GetWidth();
    int GetHeight();

private:

    int width;
    int height;
    int *dataArray;

    QVector <Vector3> m_vVertices;		//vertices vector
    QVector <QVector <int> > m_vFaces;			//Faces vector

    QVector <Vector3> triangleBounds;

};
