#ifndef __SHADOWMESH_H
#define __SHADOWMESH_H

//#include <gl/glew.h>
//#include <glut.h>
#include "glew.h"
#include <QtOpenGL>

#include "ObjFile.h"

#include "PlaneMesh.h"

class ShadowMesh {

public:

	ShadowMesh();
	
	void LoadInputMesh(char *filename);	
	float GetBoundingSphereRad();	
		
	void PlaceVertsBeneathSphere(float boundingSphereRad);	
	void SetPointLightPosition(Vector3 p);

	//software-based shadowing	
        void SetShadowCasters(vector <vector <Triangle> > &planeCuts);
	void ComputeShadows();
	void DrawMesh(); 

	//hardware-based shadowing using GLSL shader
	void DrawMeshUnshaded(); 	

private:

	//helpers for software-based shadowing
	bool LineShadowCasterIntersect(Vector3 pt1, Vector3 pt2);
	//method 1
	bool LineTriangleIntersect(Triangle &tri, Vector3 &pt1, Vector3 &pt2, Vector3 &intersectPoint);	
	//method improved
	bool LinePlaneIntersect(Triangle &tri, Vector3 &pt1, Vector3 &pt2, Vector3 &intersectPoint);
	bool PointTriangleIntersect(Triangle &tri, Vector3 &intersectPoint);

	ObjFile *inputMesh;
	double boundingSphereRad;

	Vector3 pointLightPos;
        vector <vector <Triangle> > shadowCasters;
	vector <Vector3> shadeValues;
	
};

#endif // __SHADOWMESH_H
