#pragma once

#include <QGLWidget>

#include "SampleCamera.h"
#include "PlaneMesh.h"
#include "glwidget.h"

class GLWidget;

class SideGLWidget : public QGLWidget
{

public:

    SideGLWidget(PlaneMesh *p);

    QSize minimumSizeHint() const;
    QSize sizeHint() const;

    void SetGLWidget(GLWidget *w);

protected:

    void initializeGL();
    void paintGL();
    void resizeGL(int width, int height);
    void mousePressEvent(QMouseEvent *event);
    void mouseMoveEvent(QMouseEvent *event);
    void mouseReleaseEvent(QMouseEvent *event);
    void keyReleaseEvent(QKeyEvent *event);

    void SetCameraPosition();

    SampleCamera m_camera;
    PlaneMesh *m_pPlaneMesh;
    GLWidget *m_pGLWidget;

    int m_nWidth;
    int m_nHeight;

    QPoint lastPos; //last mouse position
    bool m_bMovedMouseAfterClick;

};

